<?xml version="1.0" encoding="ASCII"?>
<pogoDsl:PogoSystem xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:pogoDsl="http://www.esrf.fr/tango/pogo/PogoDsl">
  <classes name="KeithleyMultimeters" pogoRevision="8.2">
    <description description="Device to interface a Keithley multimeters 2701. &lt;br>&#xA;The Keithley is configured in Voltmeter &lt;br>&#xA;The ReadBufferedData command initiate a scan and &lt;br>&#xA;readback data stored in the Keithley buffer up to 450000 points. &lt;br>&#xA;nbPoins and nPLC attributes are INVALID in RUNNING state (while Keithley integrates)." title="" sourcePath="/home/informatique/ica/elattaoui/devSrc/SVN/KeithleyMultimeters/src" language="Cpp" filestogenerate="XMI   file,Code files,html Pages" license="GPL" hasMandatoryProperty="false" hasConcreteProperty="true" hasAbstractCommand="false" hasAbstractAttribute="false" descriptionHtmlExists="true">
      <inheritances classname="Device_Impl" sourcePath=""/>
      <identification contact="at synchrotron-soleil.fr - xavier.elattaoui" author="xavier.elattaoui" emailDomain="synchrotron-soleil.fr" classFamily="Acquisition" siteSpecific="" platform="All Platforms" bus="Ethernet" manufacturer="Keithley" reference="2701"/>
    </description>
    <deviceProperties name="CommunicationLinkName" description="Name of the device which handles the communication protocol">
      <type xsi:type="pogoDsl:StringType"/>
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
    </deviceProperties>
    <deviceProperties name="SpecificConfiguration" description="User Keithley configuration">
      <type xsi:type="pogoDsl:StringVectorType"/>
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
    </deviceProperties>
    <commands name="State" description="This command gets the device state (stored in its device_state data member) and returns it to the caller." execMethod="dev_state" displayLevel="OPERATOR" polledPeriod="0">
      <argin description="none">
        <type xsi:type="pogoDsl:VoidType"/>
      </argin>
      <argout description="Device state">
        <type xsi:type="pogoDsl:StateType"/>
      </argout>
      <status abstract="true" inherited="true" concrete="true" concreteHere="true"/>
    </commands>
    <commands name="Status" description="This command gets the device status (stored in its device_status data member) and returns it to the caller." execMethod="dev_status" displayLevel="OPERATOR" polledPeriod="0">
      <argin description="none">
        <type xsi:type="pogoDsl:VoidType"/>
      </argin>
      <argout description="Device status">
        <type xsi:type="pogoDsl:ConstStringType"/>
      </argout>
      <status abstract="true" inherited="true" concrete="true"/>
    </commands>
    <commands name="ReadBufferedData" description="Command to read back acquired/buffered data" execMethod="read_buffered_data" displayLevel="OPERATOR" polledPeriod="0">
      <argin description="no argin">
        <type xsi:type="pogoDsl:VoidType"/>
      </argin>
      <argout description="no argout">
        <type xsi:type="pogoDsl:VoidType"/>
      </argout>
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
    </commands>
    <commands name="WriteRead" description="Direct access to send (SCPI) low level commands to the instrument" execMethod="write_read" displayLevel="EXPERT" polledPeriod="0">
      <argin description="Low level command to send">
        <type xsi:type="pogoDsl:StringType"/>
      </argin>
      <argout description="Command response (if any)">
        <type xsi:type="pogoDsl:StringType"/>
      </argout>
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
    </commands>
    <commands name="Abort" description="Command to stop/abort acquisition" execMethod="abort" displayLevel="EXPERT" polledPeriod="0">
      <argin description="no argin">
        <type xsi:type="pogoDsl:VoidType"/>
      </argin>
      <argout description="no argout">
        <type xsi:type="pogoDsl:VoidType"/>
      </argout>
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
    </commands>
    <commands name="Configure" description="Sends the user configuration defined in property." execMethod="configure" displayLevel="EXPERT" polledPeriod="0">
      <argin description="no argin">
        <type xsi:type="pogoDsl:VoidType"/>
      </argin>
      <argout description="no argout">
        <type xsi:type="pogoDsl:VoidType"/>
      </argout>
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
    </commands>
    <commands name="StartAcquisition" description="Command to start a new acquisition" execMethod="start_acquisition" displayLevel="OPERATOR" polledPeriod="0">
      <argin description="no argin">
        <type xsi:type="pogoDsl:VoidType"/>
      </argin>
      <argout description="nio argout">
        <type xsi:type="pogoDsl:VoidType"/>
      </argout>
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
    </commands>
    <attributes name="nPLC" attType="Scalar" rwType="READ_WRITE" displayLevel="OPERATOR" polledPeriod="0" maxX="" maxY="" allocReadMember="false" isDynamic="false">
      <dataType xsi:type="pogoDsl:DoubleType"/>
      <changeEvent fire="false" libCheckCriteria="false"/>
      <archiveEvent fire="false" libCheckCriteria="false"/>
      <dataReadyEvent fire="false" libCheckCriteria="true"/>
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
      <properties description="Integration rate in line cycles in the range [0.002,50]" label="nPLC" unit="" standardUnit="" displayUnit="" format="%4.2f" maxValue="50" minValue="0.002" maxAlarm="" minAlarm="" maxWarning="" minWarning="" deltaTime="" deltaValue=""/>
    </attributes>
    <attributes name="triggerSource" attType="Scalar" rwType="READ_WRITE" displayLevel="OPERATOR" polledPeriod="0" maxX="" maxY="" allocReadMember="false" isDynamic="false">
      <dataType xsi:type="pogoDsl:StringType"/>
      <changeEvent fire="false" libCheckCriteria="false"/>
      <archiveEvent fire="false" libCheckCriteria="false"/>
      <dataReadyEvent fire="false" libCheckCriteria="true"/>
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
      <properties description="Select control source (IMMediate, TIMer, MANual, BUS or EXTernal)." label="triggerSource" unit="" standardUnit="" displayUnit="" format="%s" maxValue="" minValue="" maxAlarm="" minAlarm="" maxWarning="" minWarning="" deltaTime="" deltaValue=""/>
    </attributes>
    <attributes name="nbPoints" attType="Scalar" rwType="READ_WRITE" displayLevel="OPERATOR" polledPeriod="0" maxX="" maxY="" allocReadMember="false" isDynamic="false">
      <dataType xsi:type="pogoDsl:UIntType"/>
      <changeEvent fire="false" libCheckCriteria="false"/>
      <archiveEvent fire="false" libCheckCriteria="false"/>
      <dataReadyEvent fire="false" libCheckCriteria="true"/>
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
      <properties description="Acquisition number of points" label="nb points" unit="" standardUnit="" displayUnit="" format="%d" maxValue="" minValue="" maxAlarm="" minAlarm="" maxWarning="" minWarning="" deltaTime="" deltaValue=""/>
    </attributes>
    <attributes name="nbBufferizedPoints" attType="Scalar" rwType="READ" displayLevel="OPERATOR" polledPeriod="0" maxX="" maxY="" allocReadMember="false" isDynamic="false">
      <dataType xsi:type="pogoDsl:UIntType"/>
      <changeEvent fire="false" libCheckCriteria="false"/>
      <archiveEvent fire="false" libCheckCriteria="false"/>
      <dataReadyEvent fire="false" libCheckCriteria="true"/>
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
      <properties description="Number of points in the Keithley buffer" label="nb bufferized points" unit="" standardUnit="" displayUnit="" format="%d" maxValue="" minValue="" maxAlarm="" minAlarm="" maxWarning="" minWarning="" deltaTime="" deltaValue=""/>
    </attributes>
    <attributes name="data" attType="Spectrum" rwType="READ" displayLevel="OPERATOR" polledPeriod="0" maxX="450000" maxY="" allocReadMember="false" isDynamic="false">
      <dataType xsi:type="pogoDsl:DoubleType"/>
      <changeEvent fire="false" libCheckCriteria="false"/>
      <archiveEvent fire="false" libCheckCriteria="false"/>
      <dataReadyEvent fire="false" libCheckCriteria="true"/>
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
      <properties description="Keithley bufferised data" label="data" unit="" standardUnit="" displayUnit="" format="%6.3f" maxValue="" minValue="" maxAlarm="" minAlarm="" maxWarning="" minWarning="" deltaTime="" deltaValue=""/>
    </attributes>
    <states name="RUNNING" description="Acquisition is on the way">
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
    </states>
    <states name="STANDBY" description="Ready for a new acquisition">
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
    </states>
    <states name="FAULT" description="Device initailisation failed or an error occured">
      <status abstract="false" inherited="false" concrete="true" concreteHere="true"/>
    </states>
    <preferences docHome="../doc/doc_html" makefileHome="$(TANGO_HOME)"/>
  </classes>
</pogoDsl:PogoSystem>
